unit CustomShape;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, loadandsave, PropEdits, LazLogger;  //Neue Anforderung IDEIntf

type
  TArrayData = array of TPoint;

type

   { TMyShape }

   TMyShape = class (TObject)
   private

   protected

   public
    FPolygon : array of TPoint;
    constructor Create;
   end;

type

    { TPropertyCustomShape }

    TPropertyCustomShape = class (TPropertyEditor)
    private
     Editor        : TCustomForm;
     DrawPanel     : TPanel;
     Buttons       : array [0..4] of TButton;
     FCustomValues : TMyShape;
     FStart        : boolean;
     FDrawing      : boolean;
     FPolygon      : array of TPoint;
     FCount        : integer;
     FStartPoint   : TPoint;
    protected
     procedure DoShowEditor;
     procedure ButtonsOnClick(Sender : TObject);
     procedure New;
     procedure Apply;
     procedure DrawPanelPaint(Sender : TObject);
     procedure DrawPanelMouseDown(Sender: TObject; Button: TMouseButton;Shift: TShiftState; X, Y: Integer);
     procedure DrawPanelMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
     procedure DrawPanelMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    public
     procedure Edit; Override;
     function  GetValue: string;Override;
     function  GetAttributes: TPropertyAttributes; Override;

    end;




type

  { TCustomShape }

  TCustomShape = class(TCustomControl)
  private
   FMyShape : TMyShape;
   FPath    : string;
   procedure SetMyShape(AValue: TMyShape);
  protected

  public
   constructor Create(AOwner: TComponent); override;
   destructor  Destroy; override;
   procedure   Paint; override;
  published
   property MyShape : TMyShape read FMyShape write SetMyShape;
  end;

procedure Register;

implementation

procedure Register;
begin
  {$I customshape_icon.lrs}
  RegisterComponents('Misc',[TCustomShape]);
  RegisterPropertyEditor(TypeInfo(TMyShape),nil,'MyShape',TPropertyCustomShape);
end;


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX---TPropertyCustomShape---XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
{ TPropertyCustomShape }

procedure TPropertyCustomShape.Edit;
begin
  inherited Edit;
  DoShowEditor;
end;

function TPropertyCustomShape.GetValue: string;
begin
 //Result:=inherited GetValue;
  result := 'DrawACustomShape';  //Das ist der Text der im OI angezeigt wird, kann man eingeben was man will!
end;

function TPropertyCustomShape.GetAttributes: TPropertyAttributes;
begin
 Result:=inherited GetAttributes;
 Result := [paMultiSelect, paDialog];  //wird benötigt das die Schaltfläche im OI erscheint
end;

procedure TPropertyCustomShape.DoShowEditor;
var lv : integer;
begin
 try
   Editor                := TForm.Create(Application);
   Editor.Width          := 715;
   Editor.Height         := 510;
   Editor.Left           := (screen.Width div 2) - (Editor.Width div 2);
   Editor.Top            := (screen.Height div 2) -(Editor.Height div 2);
   Editor.BorderStyle    := bsSingle;
   Editor.Caption        := 'Draw A CustomShape';

   FCustomValues         := TMyShape.Create;

   DrawPanel             := TPanel.Create(nil);
   DrawPanel.Parent      := Editor;
   DrawPanel.SetBounds(5,5,500,500);
   DrawPanel.Color       := clWhite;
   DrawPanel.BevelInner  := bvLowered;
   DrawPanel.BevelOuter  := bvRaised;
   DrawPanel.OnPaint     := @DrawPanelPaint;
   DrawPanel.OnMouseDown := @DrawPanelMouseDown;
   DrawPanel.OnMouseMove := @DrawPanelMouseMove;
   DrawPanel.OnMouseUp   := @DrawPanelMouseUp;

   for lv:=0 to 4 do
    begin
     Buttons[lv]           := TButton.Create(nil);
     Buttons[lv].Parent    := Editor;
     Buttons[lv].Left      := 510;
     Buttons[lv].Width     := 200;
     Buttons[lv].Height    :=  30;
     Buttons[lv].Top       := 5 + (lv*(Buttons[lv].Height+5));
     Buttons[lv].OnClick   := @ButtonsOnClick;
     Buttons[lv].Tag       := lv;
    end;
   Buttons[0].Caption:= 'New';//rs_new;
   Buttons[1].Caption:= 'Apply';//rs_apply;
   Buttons[2].Caption:= 'Cancel';//rs_cancel;
   Buttons[3].Caption:= 'Load';//rs_load;
   Buttons[4].Caption:= 'Save';//rs_save;

   Editor.ShowModal;
 finally
   FCustomValues.Free;
   for lv:=0 to 4 do Buttons[lv].Free;
   DrawPanel.Free;
   Editor.Free;
 end;

end;

procedure TPropertyCustomShape.ButtonsOnClick(Sender: TObject);
begin
  case (Sender as TButton).Tag of
   0 : New;
   1 : Apply;
   2 : Editor.Close;
  end;
end;

procedure TPropertyCustomShape.New;
begin
 FStart := true;
 FCount := 1;
 setLength(FPolygon,0);
 DrawPanel.Invalidate;
end;

procedure TPropertyCustomShape.Apply;
begin
 FCustomValues.FPolygon := copy(FPolygon);
 SetPtrValue(FCustomValues);
 Editor.Close;
end;

procedure TPropertyCustomShape.DrawPanelPaint(Sender: TObject);
begin
 DrawPanel.Canvas.Pen.Color:= clSilver;
 DrawPanel.Canvas.Pen.Style:= psDash;
 DrawPanel.Canvas.Rectangle(5,5,105,105);
 DrawPanel.Canvas.Pen.Color:= clBlack;
 DrawPanel.Canvas.Pen.Style:= psSolid;

 if FDrawing then
  DrawPanel.Canvas.Polyline(FPolygon);
 if not FStart and not FDrawing then
  DrawPanel.Canvas.Polygon(FPolygon);

end;

procedure TPropertyCustomShape.DrawPanelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if FStart then
  begin
   FDrawing := true;
   setLength(FPolygon,FCount);
   FPolygon[FCount-1].x:=x;
   FPolygon[FCount-1].y:=y;
   FStartPoint.X:=x;
   FStartPoint.Y:=y;
   DrawPanel.Invalidate;
  end;
end;

procedure TPropertyCustomShape.DrawPanelMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
 if FDrawing then
  begin
   inc(FCount);
   setLength(FPolygon,FCount);
   FPolygon[FCount-1].x:=x;
   FPolygon[FCount-1].y:=y;
   DrawPanel.Invalidate;
  end;
end;

procedure TPropertyCustomShape.DrawPanelMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if FDrawing then
  begin
   inc(FCount);
   setLength(FPolygon,FCount);
   FPolygon[FCount-1].x:=x;
   FPolygon[FCount-1].y:=y;
   inc(FCount);
   setLength(FPolygon,FCount);
   FPolygon[FCount-1].x:=FStartPoint.X;
   FPolygon[FCount-1].y:=FStartPoint.Y;
   FDrawing := false;
   FStart := false;
   DrawPanel.Invalidate;
  end;
end;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX---TMYShape---XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
{ TMyShape }

constructor TMyShape.Create;
begin
 setlength(FPolygon,4);
 FPolygon[0].X:=2;
 FPolygon[0].Y:=2;
 FPolygon[1].X:=98;
 FPolygon[1].Y:=20;
 FPolygon[2].X:=55;
 FPolygon[2].Y:=78;
 FPolygon[3].X:=2;
 FPolygon[3].Y:=2;
end;


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX---TCustomShape---XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
{ TCustomShape }

procedure TCustomShape.SetMyShape(AValue: TMyShape);
begin
  if FMyShape=AValue then Exit;
  FMyShape.FPolygon := copy(aValue.FPolygon);
 //Speichern des Arrays
   //FPath := Application.Location;
   //SavePolygon(Application.Location+'MyShape.dat',FMyShape.FPolygon); //speichert im Lazarus Ordner!

  {$IFDEF WINDOWS}
  FPath := getenvironmentvariable('HOMEPATH');
  {$ENDIF}
  {$IFDEF Linux}
  FPath := getenvironmentvariable('HOME');
  {$ENDIF}
  SavePolygon(FPath+pathdelim+'MyShape.dat',FMyShape.FPolygon);

  Invalidate;
end;

constructor TCustomShape.Create(AOwner: TComponent);
var ArrayData: TArrayData;
begin
  inherited Create(AOwner);
  Width := 100;
  Height:= 100;

  FMyShape := TMyShape.Create;

  //LADEN DES Arrays
   //LoadPolygon(Application.Location+'MyShape.dat',FMyShape.FPolygon); versucht bei der Executablen zu laden!
  {$IFDEF WINDOWS}
  FPath := getenvironmentvariable('HOMEPATH');
  {$ENDIF}
  {$IFDEF Linux}
  FPath := getenvironmentvariable('HOME');
  {$ENDIF}
  if fileexists(FPath+pathdelim+'MyShape.dat') then
   begin
    LoadPolygon(FPath+pathdelim+'MyShape.dat',ArrayData);
    FMyShape.FPolygon := copy(ArrayData);
   end;
end;

destructor TCustomShape.Destroy;
begin
  FMyShape.Free;
  inherited Destroy;
end;

procedure TCustomShape.Paint;
begin
  inherited Paint;
  Canvas.Brush.Color := clYellow;
  Canvas.Polygon(FMyShape.FPolygon);
end;

end.
